# End to End Lip Synchronization with a Temporal AutoEncoder

This repository contains the code for the paper End to End Lip Synchronization with a Temporal AutoEncoder.

## Prerequisites
The following packages are required:
```
pytorch 1.0.1
ffmpeg 3.4.2
imgaug 0.2.7
movieoy 0.2.3.5
numpy 1.15.0
opencv 3.4.1
python 3.6.7
pytorch 1.0.1
scipy 1.2.0
tensorboard 1.13.1
imageio 2.2.0
OpenFace 2.1.0
```

May also work using other versions.

## General
Install open face
https://github.com/TadasBaltrusaitis/OpenFace
Compile and install into ./OpenFace/

## Training weights
Are not attached because of the size limit for the supplementary materials.

## Main files descriptions
dbs_config.yaml 
DB related parameters

db_gen.py
a script for generating the data set (supports lrs2-BBC and TCD-TIMIT)

Utils/generate_frames_from_videos.py
part of the dataset generation, should be executed after db_gen.py

Utils/generate_acnhors.py
part of the dataset generation, should be executed after generate_frames_from_videos.py

If generating a validation or test db, then finally run:
Model/genrate_test_db.py

Syncnet
Scripts for the initial training phase. 
After training, the output folder will contain the inital training weights.

Model/config.yaml
train-eval parameters

dataset.py
the dataset provider

DTA.py
The modified DTA evaluation script

eval*.py, report*.py
evaluation scripts

train.py
the training script

model.py
the model script

networks.py
definitions of neural networks 